;##################################################################
; LISTVIEW
;##################################################################
#include "ListView.Inc"

LVSORT struct
	handle dd
	direction dd
	column dd
	type dd
ENDS

.DATA
	szColumn0			DB			"Column 0",0
	szColumn1			DB			"Column 1",0
	szColumn2			DB			"Column 2",0
	szColumn3			DB			"Column 3",0
	
	MenuString0			DB			"Menu string 0",0
	MenuString1			DB			"Menu string 1",0
	MenuString2			DB			"Menu string 2",0
	MenuString3			DB			"Menu string 3",0
	MenuString4			DB			"Menu string 4",0
	MenuString5			DB			"Menu string 5",0
	MenuLabel			DB			"Test menu",0

	hInstance			DD 			?
	icc	 				DQ			3FFF00000008h
	hDlg				DD			?
	hListView			DD			?
	hHeader				DD			?
	hClipData			DD			?
	hIml				DD			?
	
	buffer				DB			256 DUP (?)
	ArialFont			LOGFONT		<-13,0,0,0,FW_NORMAL,FALSE,FALSE,0,0,0,0,0,0,"Arial">
	hArialFont			DD			?
	ComicFont			LOGFONT		<-13,0,0,0,FW_NORMAL,FALSE,FALSE,0,0,0,0,0,0,"Comic Sans MS">
	hComicFont			DD			?
	
	hMenuFont			DD			?
	lvsort				LVSORT		<>

	hBrush				DD			?
	hLVBrush			DD			?
	hMNBrush			DD			?
	hMenu				DD			?
	hSubMenu			DD			?

	SubItemClr		DD			0080FF00h,00FF8080h,0080FFFFh,00FF80FFh,00C0C0C0h

.CODE

Start:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke CreateSolidBrush,0FF8080h
	mov [hBrush],eax
	invoke CreateSolidBrush,0000FFFFh ;brush for the listview
	mov [hLVBrush],eax
	invoke CreateSolidBrush,0FFh
	mov [hMNBrush],eax
	
	invoke CreateFontIndirect,OFFSET ArialFont
	mov [hArialFont],eax
	invoke CreateFontIndirect,OFFSET ComicFont
	mov [hComicFont],eax
	mov [hMenuFont],eax
	
	invoke InitCommonControlsEx,OFFSET icc
	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0
	invoke DeleteObject,[hBrush]
	invoke DeleteObject,[hLVBrush]
	invoke DeleteObject,[hMNBrush]
	invoke DeleteObject,[hArialFont]
	invoke DeleteObject,[hComicFont]
	invoke DestroyMenu,[hSubMenu]
	invoke DestroyMenu,[hMenu]
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,ebx,esi
	LOCAL hdi		:HDITEM
	LOCAL colbrush	:D
	LOCAL lvhi		:LVHITTESTINFO
	LOCAL ps		:PAINTSTRUCT
	LOCAL rect		:RECT
	LOCAL lbr		:LOGBRUSH
	LOCAL lvi		:LVITEM

	.WM_CTLCOLORDLG
	mov ebx, [uMsg]
	cmp ebx, WM_CTLCOLORDLG
	jne >.WM_CTLCOLORSTATIC
		mov eax,[hBrush]
		ret

	.WM_CTLCOLORSTATIC
	cmp ebx, WM_CTLCOLORSTATIC
	jne >.WM_DRAWITEM
		invoke GetObject,[hBrush],SIZEOF LOGBRUSH,OFFSET lbr
		mov ebx,[wParam] ; hDC
		invoke SetBkColor,ebx,[lbr.lbColor]
		invoke SetTextColor,ebx,0000FFFFh
		mov eax,[hBrush]
		ret

	.WM_DRAWITEM
	cmp ebx, WM_DRAWITEM
	jne >>.WM_MEASUREITEM
		; maybe do some menu drawing here
		cmp D[wParam],0 ; 0 for menu items 
		jne >>.DEFPROC
			mov edi,[lParam]
			mov eax,[edi+DRAWITEMSTRUCT.CtlType]
			test eax,ODT_MENU
			je >>.DEFPROC
				mov eax,[edi+DRAWITEMSTRUCT.itemAction]
				cmp eax,ODA_DRAWENTIRE
				jne >M1
					invoke GetSysColor,COLOR_BTNFACE
					invoke SetBkColor,eax
					push eax
					invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],0
					push eax
					invoke SelectObject,[edi+DRAWITEMSTRUCT.hdc],[hMenuFont]
					push eax
					mov ebx,edi
					add ebx,DRAWITEMSTRUCT.rcItem
					invoke GetSystemMetrics,SM_CXMENUCHECK
					add [edi+DRAWITEMSTRUCT.rcItem.left],eax
					invoke DrawText,[edi+DRAWITEMSTRUCT.hdc],[edi+DRAWITEMSTRUCT.itemData],-1,ebx,DT_LEFT + DT_VCENTER + DT_SINGLELINE
					pop eax
					invoke SelectObject,[edi+DRAWITEMSTRUCT.hdc],eax
					pop eax
					invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],eax
					pop eax
					invoke SetBkColor,eax
					xor eax,eax
					inc eax
					ret
				M1:
				cmp eax,ODA_SELECT
				jne >>.DEFPROC
					; Get the item state
					mov eax,[edi+DRAWITEMSTRUCT.itemState]
					test eax,ODS_SELECTED
					je >>S1
						invoke GetObject,[hMNBrush],SIZEOF LOGBRUSH,OFFSET lbr
						invoke SetBkColor,[edi+DRAWITEMSTRUCT.hdc],[lbr.lbColor]
						push eax ; push the old background color
						invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],0FFFFFFh
						push eax
						invoke SelectObject,[edi+DRAWITEMSTRUCT.hdc],[hMenuFont]
						push eax
						mov ebx,edi
						add ebx,DRAWITEMSTRUCT.rcItem
						invoke FillRect,[edi+DRAWITEMSTRUCT.hdc],ebx,[hMNBrush]
						invoke GetSystemMetrics,SM_CXMENUCHECK
						add [edi+DRAWITEMSTRUCT.rcItem.left],eax
						invoke DrawText,[edi+DRAWITEMSTRUCT.hdc],[edi+DRAWITEMSTRUCT.itemData],-1,ebx,DT_LEFT + DT_VCENTER + DT_SINGLELINE
						pop eax
						invoke SelectObject,[edi+DRAWITEMSTRUCT.hdc],eax
						pop eax
						invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],eax
						pop eax
						invoke SetBkColor,[edi+DRAWITEMSTRUCT.hdc],eax
						xor eax,eax
						inc eax
						ret

					S1:
						invoke GetSysColor,COLOR_BTNFACE
						push eax
						invoke CreateSolidBrush,eax
						mov esi,eax
						pop eax
						invoke SetBkColor,[edi+DRAWITEMSTRUCT.hdc],eax
						push eax ; push the old background color
						invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],0
						push eax
						invoke SelectObject,[edi+DRAWITEMSTRUCT.hdc],[hMenuFont]
						push eax
						mov ebx,edi
						add ebx,DRAWITEMSTRUCT.rcItem
						pop eax
						invoke FillRect,[edi+DRAWITEMSTRUCT.hdc],ebx,esi
						invoke GetSystemMetrics,SM_CXMENUCHECK
						add [edi+DRAWITEMSTRUCT.rcItem.left],eax
						invoke DrawText,[edi+DRAWITEMSTRUCT.hdc],[edi+DRAWITEMSTRUCT.itemData],-1,ebx,DT_LEFT + DT_VCENTER + DT_SINGLELINE
						pop eax
						invoke SelectObject,[edi+DRAWITEMSTRUCT.hdc],eax
						pop eax
						invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],eax
						pop eax
						invoke SetBkColor,[edi+DRAWITEMSTRUCT.hdc],eax
						invoke DeleteObject,esi
						xor eax,eax
						inc eax
						ret

	.WM_MEASUREITEM
	cmp ebx, WM_MEASUREITEM
	jne >>.WM_NOTIFY
		mov edi,[lParam]
		cmp D[wParam],0
		jne >>.DEFPROC
			mov eax,[edi+MEASUREITEMSTRUCT.CtlType]
			test eax,ODT_MENU
			je >>.DEFPROC
				invoke GetDC,NULL
				mov ebx,eax
				invoke CreateCompatibleDC,ebx
				mov esi,eax
				invoke SelectObject,esi,[hMenuFont]
				push eax
				invoke lstrlen,[edi+MEASUREITEMSTRUCT.itemData]
				invoke GetTextExtentPoint32,esi,[edi+MEASUREITEMSTRUCT.itemData],eax,OFFSET rect
				pop ecx
				invoke SelectObject,esi,ecx
				invoke DeleteDC,esi
				invoke ReleaseDC,NULL,ebx
				invoke GetSystemMetrics,SM_CXMENUCHECK
				add eax,[rect.left]
				mov D[edi+MEASUREITEMSTRUCT.itemWidth],eax
				mov eax,[rect.top]
				mov D[edi+MEASUREITEMSTRUCT.itemHeight],eax
				xor eax,eax
				inc eax
				ret

	.WM_NOTIFY
	cmp ebx, WM_NOTIFY
	jne >>.WM_COMMAND
		mov edi,[lParam]
		cmp D[edi+NMHDR.code],HDN_ITEMCLICK
		jnz >.HDN_ITEMCHANGED
			mov D[hdi.mask],HDI_IMAGE + HDI_FORMAT
			invoke SendMessage,[hHeader],HDM_GETITEM,[edi+NMHEADER.iItem],ADDR hdi
			test D[hdi.fmt],HDF_IMAGE
			jz >>.WMN_DONE
				; D[hdi.iItem] = the header item that was clicked
				; D[hdi.iImage] = the current image
				; set to 0 = no arrow, 1 = down arrow, 2 = up arrow
				mov eax,1
				cmp D[hdi.iImage],1
				jne >
					inc eax
				:
				mov [hdi.iImage],eax
				invoke SendMessage,[hHeader],HDM_SETITEM,[edi+NMHEADER.iItem],ADDR hdi
				jmp >>.WMN_DONE

		.HDN_ITEMCHANGED
		cmp D[edi+NMHDR.code],HDN_ITEMCHANGED
		jnz >.NMCLICK
			; Redraw the listview when header resized
			invoke InvalidateRect,[hListView],NULL,NULL
			invoke UpdateWindow,[hListView]
			jmp >>.WMN_DONE

		.NMCLICK
		cmp D[edi+NMHDR.code],NM_CLICK
		jnz >>.NM_CUSTOMDRAW
			invoke GetMessagePos
			movzx ecx,ax
			mov [lvhi.pt.x],ecx
			shr eax,16
			movzx ecx,ax
			mov [lvhi.pt.y],ecx
			invoke ScreenToClient,[hListView],ADDR lvhi.pt
			invoke SendMessage,[hListView],LVM_SUBITEMHITTEST,0,ADDR lvhi
			; returns the column and item that was clicked in lvhi
			mov eax,[lvhi.iItem]
			mov [lvi.iItem],eax
			mov D[lvi.iSubItem],0
			mov D[lvi.cchTextMax],255
			mov [lvi.pszText],OFFSET buffer
			invoke SendMessage,[hListView],LVM_GETITEMTEXT,[lvhi.iItem],OFFSET lvi
			invoke SetDlgItemText,[hwnd],1002,OFFSET buffer
			jmp >>.WMN_DONE

		.NM_CUSTOMDRAW
			cmp D[edi+NMHDR.code],NM_CUSTOMDRAW
			jne >>.WMN_DONE
			mov eax,[wParam]
			cmp eax,1001
			jne >>.WMN_DONE
				mov edi,[lParam]
				mov eax,[edi+NMLVCUSTOMDRAW.nmcd.dwDrawStage]
				cmp eax,CDDS_PREPAINT
				jne >
					; Request an item draw notification
					invoke SetWindowLong,[hwnd],DWL_MSGRESULT,CDRF_NOTIFYITEMDRAW
					xor eax,eax
					inc eax
					ret
				:
				cmp eax,CDDS_ITEMPREPAINT
				jne >>P1
					; The item is about to be painted
					; intercept the paint process to do our own thing
					mov eax,[edi+NMLVCUSTOMDRAW.nmcd.uItemState]
					test eax,CDIS_SELECTED
					je >>
						; A selected item is being drawn
						; Get the item number
						mov esi,[edi+NMLVCUSTOMDRAW.nmcd.dwItemSpec]
						; Get the bounding rect of the icon
						mov D[rect.left],LVIR_ICON
						invoke SendMessage,[hListView],LVM_GETITEMRECT,esi,OFFSET rect
						push [rect.right]
						; Get the bounding rect of the item
						mov D[rect.left],LVIR_BOUNDS
						invoke SendMessage,[hListView],LVM_GETITEMRECT,esi,OFFSET rect
						pop ecx ; pop the right side of the icon
						inc ecx ; one pixel space
						mov [rect.left],ecx

						; Get the device context
						mov ebx,[edi+NMLVCUSTOMDRAW.nmcd.hdc]

						; Set the text background color
						invoke GetObject,[hLVBrush],SIZEOF LOGBRUSH,OFFSET lbr
						invoke SetBkColor,ebx,[lbr.lbColor]
						push eax ; push the old background color
						; Set the text color
						invoke SetTextColor,ebx,000000FFh
						push eax ; push the old text color

						; Get the item count from the header control
						invoke SendMessage,[hListView],LVM_GETHEADER,0,0
						invoke SendMessage,eax,HDM_GETITEMCOUNT,0,0
						mov ecx,eax

						; Loop through all the labels and draw their text
						mov [lvi.iItem],esi
						mov [lvi.pszText],OFFSET buffer
						mov D[lvi.cchTextMax],255
						; EDI is no longer needed so we'll use it for a counter
						xor edi,edi
						jmp >>W1
						W2:
							push ecx ; save the item count
							; Get the bounding rect of the label
							; the API uses the rect struct to pass parameters
							
							; Create a brush for this column (edi contains column number)
							mov eax,edi
							shl eax,2
							add eax, offset SubItemClr
							invoke CreateSolidBrush,[eax]
							mov [colbrush], eax

							mov D[rect.left],LVIR_LABEL
							mov D[rect.top],edi
							invoke SendMessage,[hListView],LVM_GETSUBITEMRECT,esi,OFFSET rect
							invoke FillRect,ebx,OFFSET rect,[colbrush]
							or edi,edi
							jz >W3
								add D[rect.left],4 ; extra indent for sub items
							W3:
							add D[rect.left],2 ; indent isn't right with LVM_GETITEM
							mov D[lvi.iSubItem],edi

							invoke SendMessage,[hListView],LVM_GETITEMTEXT,esi,OFFSET lvi
							; Draw the text to the items
							invoke DrawText,ebx,OFFSET buffer,-1,OFFSET rect,DT_LEFT + DT_VCENTER + DT_SINGLELINE

							; Delete the column brush
							invoke DeleteObject,[colbrush]
							pop ecx ; restore the item count
							inc edi
						W1:
						cmp edi,ecx ; have we reached the last item ?
						jl <<W2

						pop eax ; pop the old text color
						invoke SetTextColor,ebx,eax
						pop eax ; pop the old background color
						invoke SetBkColor,ebx,eax

						; Draw the icon and we're all done !
						mov D[lvi.mask],LVIF_IMAGE
						mov [lvi.iItem],esi
						mov D[lvi.iSubItem],0
						invoke SendMessage,[hListView],LVM_GETITEM,0,OFFSET lvi
						invoke SendMessage,[hListView],LVM_GETIMAGELIST,LVSIL_SMALL,0
						mov edi,eax
						mov D[rect.left],LVIR_ICON
						invoke SendMessage,[hListView],LVM_GETITEMRECT,esi,OFFSET rect
						invoke ImageList_Draw,edi,[lvi.iImage],ebx,[rect.left],[rect.top],ILD_BLEND50

						; The drawing is all done so skip the default draw
						invoke SetWindowLong,[hwnd],DWL_MSGRESULT,CDRF_SKIPDEFAULT
						xor eax,eax
						inc eax
						ret
					:
						; Set the text and background colors
						mov D[edi+NMLVCUSTOMDRAW.clrTextBk],0FFFFFFh
						mov D[edi+NMLVCUSTOMDRAW.clrText],0FF0000h
						; The item is not selected so use the default draw
						invoke SetWindowLong,[hwnd],DWL_MSGRESULT,CDRF_DODEFAULT
						xor eax,eax
						inc eax
						ret
				P1:
				invoke SetWindowLong,[hwnd],DWL_MSGRESULT,CDRF_DODEFAULT
				xor eax,eax
				inc eax
				ret

		.WMN_DONE
		xor eax,eax
		ret

	.WM_COMMAND
	cmp ebx, WM_COMMAND
	jne >.WM_CONTEXTMENU
		mov eax,[hListView]
		mov [lvsort.handle],eax ; Handle of the listview to sort
		mov D[lvsort.direction],FALSE ; FALSE = ascending , TRUE = descending
		mov D[lvsort.column],0 ; Column to sort
		mov D[lvsort.type],2 ; 0 = param, 1 = string, 2 = image index
		invoke SendMessage, [hListView], LVM_SORTITEMSEX, OFFSET lvsort, OFFSET LVSortProc
		jmp >>.EXIT

	.WM_CONTEXTMENU
	cmp ebx, WM_CONTEXTMENU
	jne >.WM_DESTROYCLIPBOARD
		invoke ShowLVMenu,[hwnd]
		xor eax,eax
		inc eax
		ret

	.WM_DESTROYCLIPBOARD
	cmp ebx, WM_DESTROYCLIPBOARD
	jne >.WM_INITDIALOG
		invoke GlobalFree,[hClipData]
		xor eax,eax
		inc eax
		ret

	.WM_INITDIALOG
	cmp ebx, WM_INITDIALOG
	jne >>.WM_CLOSE
		mov eax,[hwnd]
		mov [hDlg],eax
		invoke SendDlgItemMessage,[hDlg],1002,WM_SETFONT,[hArialFont],TRUE
		invoke GetDlgItem,[hDlg],1001
		mov [hListView],eax
		invoke SendMessage,[hListView],LVM_GETHEADER,0,0
		mov [hHeader],eax
		call SetUpListView
		; LVAddItem,iIcon,ptext0,ptext1,ptext2,ptext3
		invoke LVAddItem,0,"Item 1","SubItem 6",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,1,"Item 2","SubItem 1",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,0,"Item 3","SubItem 7",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,1,"Item 4","SubItem 0",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,0,"Item 5","SubItem 4",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,1,"Item 6","SubItem 3",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,0,"Item 7","SubItem 5",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,1,"Item 8","SubItem 2",OFFSET szColumn2,OFFSET szColumn3

		invoke CreateMenu
		mov [hMenu],eax
		invoke SetMenu,[hwnd],eax
		invoke CreatePopupMenu
		mov [hSubMenu],eax
		invoke AppendMenu,[hSubMenu],MF_ENABLED + MF_OWNERDRAW,5001,OFFSET MenuString0
		invoke AppendMenu,[hSubMenu],MF_ENABLED + MF_OWNERDRAW,5002,OFFSET MenuString1
		invoke AppendMenu,[hSubMenu],MF_ENABLED + MF_OWNERDRAW,5003,OFFSET MenuString2
		invoke AppendMenu,[hSubMenu],MF_ENABLED + MF_OWNERDRAW,5004,OFFSET MenuString3
		invoke AppendMenu,[hSubMenu],MF_ENABLED + MF_OWNERDRAW,5005,OFFSET MenuString4
		invoke AppendMenu,[hSubMenu],MF_ENABLED + MF_OWNERDRAW,5006,OFFSET MenuString5
		invoke InsertMenu,[hMenu],0,MF_BYPOSITION+MF_POPUP + MF_STRING,[hSubMenu],OFFSET MenuLabel
		invoke DrawMenuBar,[hwnd]
		xor eax,eax
		inc eax
		ret

	.WM_CLOSE
	cmp ebx, WM_CLOSE
	jne >.DEFPROC
		invoke EndDialog,[hwnd],0

	.DEFPROC
		xor eax,eax
		RET

	.EXIT

	xor eax,eax
	inc eax
	RET
ENDF

SetUpListView FRAME 
	uses edi,esi
	LOCAL LVColumn		:LV_COLUMN
	LOCAL hdi			:HDITEM

	invoke ImageList_Create,16,16,ILC_MASK + ILC_COLOR24,1,10
	mov [hIml],eax
	invoke LoadIcon,[hInstance],10000
	push eax
	invoke ImageList_AddIcon,[hIml],eax
	pop eax
	invoke DestroyIcon,eax
	invoke LoadIcon,[hInstance],10001
	push eax
	invoke ImageList_AddIcon,[hIml],eax
	pop eax
	invoke DestroyIcon,eax

	invoke SendMessage,[hListView],LVM_SETIMAGELIST,LVSIL_SMALL,[hIml]

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],99
	mov D[LVColumn.pszText],OFFSET szColumn0
	mov D[LVColumn.cchTextMax],SIZEOF szColumn0
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,0,ADDR LVColumn

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],99
	mov D[LVColumn.pszText],OFFSET szColumn1
	mov D[LVColumn.cchTextMax],SIZEOF szColumn1
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,1,ADDR LVColumn

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH + LVCF_SUBITEM
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],99
	mov D[LVColumn.pszText],OFFSET szColumn2
	mov D[LVColumn.cchTextMax],SIZEOF szColumn2
	mov D[LVColumn.iSubItem],1
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,2,ADDR LVColumn

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH + LVCF_SUBITEM
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],99
	mov D[LVColumn.pszText],OFFSET szColumn3
	mov D[LVColumn.cchTextMax],SIZEOF szColumn3
	mov D[LVColumn.iSubItem],2
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,3,ADDR LVColumn

	invoke SendMessage,[hListView],LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT 

	invoke ImageList_LoadImage,[hInstance],11000,16,0,08000FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	invoke SendMessage,[hHeader],HDM_SETIMAGELIST,0,eax
	mov D[hdi.mask],HDI_FORMAT + HDI_IMAGE
	mov D[hdi.fmt],HDF_IMAGE + HDF_STRING + HDF_BITMAP_ON_RIGHT
	mov D[hdi.iImage],0

	invoke SendMessage,[hHeader],HDM_GETITEMCOUNT,0,0
	dec eax
	mov edi,eax
	:
		invoke SendMessage,[hHeader],HDM_SETITEM,edi,ADDR hdi
		dec edi
	jns <

	ret
ENDF

LVAddItem FRAME Image,Col0,Col1,Col2,Col3
	LOCAL lvi		:LVITEM
	LOCAL szItemID[16]	:B
	LOCAL ItemID		:D

	invoke SendMessage,[hListView],LVM_GETITEMCOUNT,0,0
	mov [ItemID],eax

	mov D[lvi.mask],LVIF_PARAM + LVIF_TEXT + LVIF_IMAGE
	mov D[lvi.iSubItem],0
	mov eax,[Col0]
	mov [lvi.pszText],eax

	mov eax,[Image]
	mov [lvi.iImage],eax
	mov D[lvi.lParam],eax
	mov eax,[ItemID]
	mov [lvi.iItem],eax
	invoke SendMessage,[hListView],LVM_INSERTITEM,0,ADDR lvi
	mov [ItemID],eax

	mov eax,[Col1]
	mov [lvi.pszText],eax
	mov eax,[ItemID]
	mov [lvi.iItem],eax
	mov D[lvi.iSubItem],1
	mov D[lvi.mask],LVIF_TEXT
	invoke SendMessage,[hListView],LVM_SETITEM,0,ADDR lvi

	mov eax,[Col2]
	mov [lvi.pszText],eax
	mov eax,[ItemID]
	mov [lvi.iItem],eax
	mov D[lvi.iSubItem],2
	mov D[lvi.mask],LVIF_TEXT
	invoke SendMessage,[hListView],LVM_SETITEM,0,ADDR lvi

	mov eax,[Col3]
	mov [lvi.pszText],eax
	mov eax,[ItemID]
	mov [lvi.iItem],eax
	mov D[lvi.iSubItem],3
	mov D[lvi.mask],LVIF_TEXT
	invoke SendMessage,[hListView],LVM_SETITEM,0,ADDR lvi

	mov eax,[ItemID]
	ret
ENDF

ShowLVMenu FRAME hWin
	LOCAL hPopMenu  :D
	LOCAL MCommand	:D
	LOCAL lvht		:LVHITTESTINFO
	LOCAL lvi		:LVITEM
	LOCAL pClipData	:D

	jmp >
		szCopyM: db "Copy",0
		szPasteM: db "Paste",0
	:

	invoke GetCursorPos, ADDR lvht.pt
	invoke ScreenToClient,[hWin],ADDR lvht.pt
	invoke ChildWindowFromPoint, [hWin], [lvht.pt.x], [lvht.pt.y]
	cmp eax,[hListView]
	jnz >>.DONE
		invoke GetCursorPos, ADDR lvht.pt
		invoke CreatePopupMenu
		mov [hPopMenu], eax
		invoke AppendMenu, [hPopMenu], MF_STRING, 100, OFFSET szCopyM
		invoke AppendMenu, [hPopMenu], MF_STRING, 101, OFFSET szPasteM
		invoke TrackPopupMenu, [hPopMenu], TPM_LEFTALIGN + TPM_RETURNCMD,\
				[lvht.pt.x], [lvht.pt.y], NULL, [hListView], NULL
		mov [MCommand],eax
		invoke ScreenToClient, [hListView], ADDR lvht.pt
		mov D[lvht.flags],LVHT_ONITEM
		invoke SendMessage, [hListView], LVM_SUBITEMHITTEST, 0, ADDR lvht
		mov eax,[lvht.iItem]
		or eax,eax
		js >>.DONE
		cmp D[MCommand],100
		jnz >>L1
			mov [lvi.iItem], eax
			invoke OpenClipboard, [hWin]
			or eax,eax
			jz >>.DONE
				invoke EmptyClipboard
				invoke GlobalAlloc,GMEM_MOVEABLE + GMEM_ZEROINIT,4096
				mov [hClipData],eax
				invoke GlobalLock,[hClipData]
				mov [lvi.pszText], eax
				mov eax,[lvht.iSubItem]
				mov [lvi.iSubItem], eax
				mov D[lvi.mask], LVIF_TEXT
				mov D[lvi.cchTextMax], 4095
				invoke SendMessage, [hListView], LVM_GETITEM, 0, ADDR lvi
				invoke GlobalUnlock,[hClipData]
				invoke SetClipboardData, CF_TEXT, [hClipData]
				invoke CloseClipboard
				jmp >>.DONE

		L1:
		cmp D[MCommand],101
		jnz >>.DONE
			mov [lvi.iItem], eax
			mov eax,[lvht.iSubItem]
			mov [lvi.iSubItem], eax
			mov D[lvi.mask], LVIF_TEXT
			invoke IsClipboardFormatAvailable, CF_TEXT
			or eax,eax
			jz >P2
				invoke OpenClipboard, [hWin]
				or eax,eax
				jz >P2
					invoke GetClipboardData, CF_TEXT
					or eax,eax
					jz >P1
						push eax
						invoke GlobalLock,eax
						mov [lvi.pszText], eax
						invoke SendMessage, [hListView], LVM_SETITEM, 0, ADDR lvi
						pop eax
						invoke GlobalUnlock,eax
					P1:
					invoke CloseClipboard
			P2:
			invoke DestroyMenu, [hPopMenu]

	.DONE
	ret

ENDF

LVSortProc FRAME lParam1,lParam2,lParamSort
	uses ebx,edi,esi
	LOCAL	ItemData1		:LVITEM
	LOCAL	ItemData2		:LVITEM
	LOCAL	Tbuff1[256]		:B
	LOCAL	Tbuff2[256]		:B

	; lParamSort pointer to LVSORT structure
	mov edi,[lParamSort]
	mov ebx,[edi+LVSORT.column]
	mov esi,[edi+LVSORT.handle]

	mov eax,[lParam1]
	mov [ItemData1.iItem],eax
	mov [ItemData1.iSubItem],ebx
	mov D[ItemData1.mask],LVIF_TEXT + LVIF_PARAM + LVIF_IMAGE
	lea eax,Tbuff1
	mov [ItemData1.pszText],eax
	mov D[ItemData1.cchTextMax],255
	invoke SendMessage,esi,LVM_GETITEM,0,OFFSET ItemData1

	mov eax,[lParam2]
	mov [ItemData2.iItem],eax
	mov [ItemData2.iSubItem],ebx
	mov D[ItemData2.mask],LVIF_TEXT + LVIF_PARAM + LVIF_IMAGE
	lea eax,Tbuff2
	mov [ItemData2.pszText],eax
	mov D[ItemData2.cchTextMax],255
	invoke SendMessage,esi,LVM_GETITEM,0,OFFSET ItemData2

	cmp D[edi+LVSORT.type],1
	mov edi,[edi+LVSORT.direction]
	jb >P1
	ja >I1
	
	; String sort
	invoke lstrcmpi,OFFSET Tbuff1,OFFSET Tbuff2
	or edi,edi
	jz >
		neg eax
	:
	ret

	; lParam sort
	P1:
	mov eax,[ItemData2.lParam]
	mov ecx,[ItemData1.lParam]
	cmp ecx,eax
	jae >
		mov eax,-1
		jmp >P2
	:
	jne >
		mov eax,0
		jmp >P2
	:
		mov eax,1
	P2:
	or edi,edi
	jz >
		neg eax
	:
	ret

	; Image sort
	I1:
	mov eax,[ItemData2.iImage]
	mov ecx,[ItemData1.iImage]
	cmp ecx,eax
	jae >
		mov eax,-1
		jmp >I2
	:
	jne >
		mov eax,0
		jmp >I2
	:
		mov eax,1
	I2:
	or edi,edi
	jz >
		neg eax
	:
	ret

ENDF
